#ifndef __DRV_LSM6DS3TR_C_H__
#define __DRV_LSM6DS3TR_C_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>
#include "lsm6ds3tr-c_reg.h"

/*STRUCTION -----------------------------------------------------*/
typedef enum{
	LSM_ACC_ODR_OFF   		= LSM6DS3TR_C_XL_ODR_OFF,																		//رռٶ
	
	LSM_ACC_ODR_12HZ5 		= LSM6DS3TR_C_XL_ODR_12Hz5,																	//Ƶ - 12.5
	
	LSM_ACC_ODR_104HZ 		= LSM6DS3TR_C_XL_ODR_104Hz,																	//Ƶ - 104
	
	LSM_ACC_ODR_208HZ			= LSM6DS3TR_C_XL_ODR_208Hz,																	//Ƶ - 208
	
	LSM_ACC_ODR_416HZ			= LSM6DS3TR_C_XL_ODR_416Hz,																	//Ƶ - 416
	
	LSM_ACC_ODR_833HZ			= LSM6DS3TR_C_XL_ODR_833Hz,																	//Ƶ - 833
		
} LSM_ACC_ODR_e;

typedef enum{
	LSM_GRY_ODR_OFF   		= LSM6DS3TR_C_GY_ODR_OFF,																		//ر
	
	LSM_GRY_ODR_12HZ5 		= LSM6DS3TR_C_GY_ODR_12Hz5,																	//Ƶ - 12.5
	
	LSM_GRY_ODR_104HZ 		= LSM6DS3TR_C_GY_ODR_104Hz,																	//Ƶ - 104
	
	LSM_GRY_ODR_208HZ 		= LSM6DS3TR_C_GY_ODR_208Hz,																	//Ƶ - 208

	LSM_GRY_ODR_416HZ 		= LSM6DS3TR_C_GY_ODR_416Hz,																	//Ƶ - 416

	LSM_GRY_ODR_833HZ 		= LSM6DS3TR_C_GY_ODR_833Hz,																	//Ƶ - 833	
	
} LSM_GRY_ODR_e;

typedef enum{
	LSM_MAG_ODR_OFF   		= 0x00,																											//رյشż
	
	LSM_MAG_ODR_10HZ 			= 0x31,																											//Ƶ - 10
	
	LSM_MAG_ODR_100HZ 		= 0x39,																											//Ƶ - 100
	
	LSM_MAG_ODR_200HZ 		= 0x3D,																											//Ƶ - 200
	
} LSM_MAG_ODR_e;

typedef enum{
	LSM_FIFO_ODR_OFF   		= LSM6DS3TR_C_FIFO_DISABLE,																	//رFIFO
	
	LSM_FIFO_ODR_12HZ5 		= LSM6DS3TR_C_FIFO_12Hz5,																		//Ƶ - 12.5
	
	LSM_FIFO_ODR_104HZ 		= LSM6DS3TR_C_FIFO_104Hz,																		//Ƶ - 104
	
	LSM_FIFO_ODR_208HZ 		= LSM6DS3TR_C_FIFO_208Hz,																		//Ƶ - 208
	
	LSM_FIFO_ODR_416HZ 		= LSM6DS3TR_C_FIFO_416Hz,																		//Ƶ - 416
	
	LSM_FIFO_ODR_833HZ 		= LSM6DS3TR_C_FIFO_833Hz,																		//Ƶ - 833
		
} LSM_FIFO_ODR_e;

typedef enum{
	LSM_ACC_POWER_MODE_HIGH_PERFORMANCE		=	LSM6DS3TR_C_XL_HIGH_PERFORMANCE,					//ٶȹģʽ - 
	
	LSM_ACC_POWER_MODE_NORMAL							=	LSM6DS3TR_C_XL_NORMAL,										//ٶȹģʽ - 
	
} LSM_ACC_POWER_MODE_e;

typedef enum{
	LSM_GRY_POWER_MODE_HIGH_PERFORMANCE		=	LSM6DS3TR_C_GY_HIGH_PERFORMANCE,					//ǹģʽ - 
	
	LSM_GRY_POWER_MODE_NORMAL							=	LSM6DS3TR_C_GY_NORMAL,										//ǹģʽ - 
	
} LSM_GRY_POWER_MODE_e;

typedef enum{
	LSM_TIMESTAMP_6MS4		=	LSM6DS3TR_C_LSB_6ms4,																			//ʱ - 6.4
	
	LSM_TIMESTAMP_25US		=	LSM6DS3TR_C_LSB_25us,																			//ʱ - 25΢
	
} LSM_TIMESTAMP_RESOLUTION_e;

typedef enum{
	LSM_TIMESTAMP_OFF			=	0,																												//ʱر
	
	LSM_TIMESTAMP_ON			=	1,																												//ʱ
	
} LSM_TIMESTAMP_SWITCH_e;

typedef enum{
	LSM_ACC_FS_2G   			= LSM6DS3TR_C_2g,																						// - 2ٶ
	
	LSM_ACC_FS_16G   			= LSM6DS3TR_C_16g,																					// - 16ٶ
	
} LSM_ACC_FS_e;

typedef enum{
	LSM_GRY_FS_250DPS			=	LSM6DS3TR_C_250dps,																				// - 250ٶ/
	
	LSM_GRY_FS_2000DPS	  = LSM6DS3TR_C_2000dps,																			// - 2000ٶ/
	
} LSM_GRY_FS_e;

typedef enum{
	LSM_MAG_FS_30GS   		= 0x00,																											// - 30˹
	
} LSM_MAG_FS_e;

typedef struct 
{
	LSM_ACC_POWER_MODE_e				acc_power_mode;																				//ٶȹģʽ
	
	LSM_GRY_POWER_MODE_e				gry_power_mode;																				//ǹģʽ
	
	LSM_FIFO_ODR_e							fifo_odr;																							//FIFOƵ
	
	LSM_TIMESTAMP_RESOLUTION_e	timestamp_resolution;																	//ʱ
	
	LSM_TIMESTAMP_SWITCH_e			timestamp_switch;																			//ʱأעʱʺFIFOһ
	
	LSM_ACC_ODR_e								acc_odr;																							//ٶȲƵ
	
	LSM_GRY_ODR_e								gry_odr;																							//ǲƵ
	
	LSM_MAG_ODR_e								mag_odr;																							//شżƲƵ
	
	LSM_ACC_FS_e								acc_fs;																								//ٶ
	
	LSM_GRY_FS_e								gry_fs;																								//
	
	LSM_MAG_FS_e								mag_fs;																								//شż
	
} drv_lsm_config_param_t;

typedef struct
{
	int16_t 							acc[3];																											//ٶ
	
	int16_t 							gry[3];																											//
	
  int16_t 							mag[3];																											//شż
	
	int32_t 							fifo_timestamp;																							//fifoʱ		
	
} lsm_data_t;

/*API -------------------------------------------------------*/
/**
	@brief 		ʼLSM
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_Init(void);
/**
	@brief 		LSMϵ
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_power_off(void);
/**
	@brief 		LSMϵ磨Ĭù
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_power_on(void);
/**
	@brief 		üٶȹģʽ
	@param 		acc_power_mode 				- [in]	ٶȹģʽ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_acc_power_mode(LSM_ACC_POWER_MODE_e acc_power_mode);
/**
	@brief 		ǹģʽ
	@param 		gry_power_mode 				- [in]	ǹģʽ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_gry_power_mode(LSM_GRY_POWER_MODE_e gry_power_mode);
/**
	@brief 		ʱ
	@param 		timestamp_resolution 	- [in]	ʱ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_timestamp_resolution(LSM_TIMESTAMP_RESOLUTION_e timestamp_resolution);
/**
	@brief 		ʱ
	@param 		timestamp_switch 			- [in]	ʱ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_timestamp_switch(LSM_TIMESTAMP_SWITCH_e timestamp_switch);
/**
	@brief 		FIFOƵ
	@param 		fifo_odr 							- [in]	FIFOƵ
	@param 		acc_odr 							- [in]	ٶȲƵ
	@param 		gry_odr 							- [in]	ǲƵ
	@param 		mag_odr 							- [in]	شżƲƵ
	@param 		timestamp_switch 			- [in]	ʱ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_fifo_odr(LSM_FIFO_ODR_e fifo_odr, LSM_ACC_ODR_e acc_odr, LSM_GRY_ODR_e gry_odr, LSM_MAG_ODR_e mag_odr, LSM_TIMESTAMP_SWITCH_e timestamp_switch);
/**
	@brief 		ACC
	@param 		acc_fs 								- [in]	ACC
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_acc_fs(LSM_ACC_FS_e acc_fs);
/**
	@brief 		ACCƵ
	@param 		acc_odr 							- [in]	ACCƵ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_acc_odr(LSM_ACC_ODR_e acc_odr);
/**
	@brief 		GRY
	@param 		gry_fs 								- [in]	GRY
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_gry_fs(LSM_GRY_FS_e gry_fs);
/**
	@brief 		GRYƵ
	@param 		gry_odr 							- [in]	GRYƵ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_gry_odr(LSM_GRY_ODR_e gry_odr);
/**
	@brief 		ȡMAGҪĲ
	@return 								- [out]	MAGҪĲ
*/
int	drv_lsm_get_mag_fs_flow(void);
/**
	@brief 		MAG
	@param 		mag_fs 								- [in]	MAG
	@param 		flow 									- [in]	ǰҪĲ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_mag_fs(LSM_MAG_FS_e mag_fs, int flow);
/**
	@brief 		ȡMAGƵҪĲ
	@return 								- [out]	MAGƵҪĲ
*/
int	drv_lsm_get_mag_odr_flow(void);
/**
	@brief 		MAGƵ
	@param 		mag_odr 							- [in]	MAGƵ
	@param 		set_hub 							- [in]	Ƿhub
	@param 		flow 									- [in]	ǰҪĲ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_set_mag_odr(LSM_MAG_ODR_e mag_odr, bool set_hub, int flow);
/**
	@brief 		ȡLSMò
	@param 		param 								- [in]	LSMò
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_get_config_param(drv_lsm_config_param_t	*p_param);
/**
	@brief 		ǰLSMFIFOм
	@return 								- [out]	FIFOǰм
*/
int	drv_lsm_get_fifo_group_num(void);
/**
	@brief 		ȡLSMFIFO
	@param 		p_data 								- [out]	صFIFO
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_get_fifo_data(lsm_data_t	*p_data);
/**
	@brief 		ȡLSMACC
	@param 		p_data 								- [out]	صACC
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_lsm_get_acc_data(lsm_data_t	*p_data);
/**
	@brief 		LSMԼ첽֡1ִȴ100msȶִв2
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_self_check_1(void);
/**
	@brief 		LSMԼ첽֡2ִȴ100msȶִв3
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_self_check_2(void);
/**
	@brief 		LSMԼ첽֡3ִȴ150msȶִв4
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_self_check_3(void);
/**
	@brief 		LSMԼ첽֡4ִȴ50msȶִв5
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_self_check_4(void);
/**
	@brief 		LSMԼ첽֡5ȡԼ
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_lsm_self_check_5(void);



#ifdef __cplusplus
}
#endif

#endif




















