#ifndef __DRV_QMC6310_V2_H__
#define __DRV_QMC6310_V2_H__

#ifdef __cplusplus
extern "C" {
#endif

/*Includes ------------------------------------------------------*/
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>

/*STRUCTION -----------------------------------------------------*/
typedef enum{
	QMC_MAG_ODR_OFF   		= 0x00,																											//رյشż
	
	QMC_MAG_ODR_10HZ 			= 0x31,																											//Ƶ - 10
	
	QMC_MAG_ODR_100HZ 		= 0x39,																											//Ƶ - 100
	
	QMC_MAG_ODR_200HZ 		= 0x3D,																											//Ƶ - 200
	
} QMC_MAG_ODR_e;

typedef enum{
	QMC_MAG_FS_30GS   		= 0x00,																											// - 30˹
	
} QMC_MAG_FS_e;
typedef struct 
{
	QMC_MAG_ODR_e					mag_odr;																										//شżƲƵ
	
	QMC_MAG_FS_e					mag_fs;																											//شż
	
} drv_qmc_config_param_t;

typedef struct
{
  int16_t 							mag[3];																											//شż
	
} qmc_data_t;


/*API -------------------------------------------------------*/
/**
	@brief 		ʼQMC6310
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qmc6310_Init(void);
/**
	@brief 		QMC6310ϵ
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qmc6310_power_off(void);
/**
	@brief 		QMC6310ϵ磨Ĭù
	@param 		
	@return 								- [out]	-1ʧܣ0ɹ
*/
int drv_qmc6310_power_on(void);
/**
	@brief 		MAG
	@param 		mag_fs 								- [in]	MAG
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qmc6310_set_mag_fs(QMC_MAG_FS_e mag_fs);
/**
	@brief 		ȡMAGƵҪĲ
	@return 								- [out]	MAGƵҪĲ
*/
int	drv_qmc6310_get_mag_odr_flow(void);
/**
	@brief 		MAGƵ
	@param 		mag_odr 							- [in]	MAGƵ
	@param 		flow 									- [in]	ǰҪĲ
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qmc6310_set_mag_odr(QMC_MAG_ODR_e mag_odr, int flow);
/**
	@brief 		ȡLSMò
	@param 		param 								- [in]	LSMò
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qmc6310_get_config_param(drv_qmc_config_param_t	*p_param);
/**
	@brief 		ȡLSMACC
	@param 		p_data 								- [out]	صACC
	@return 								- [out]	-1ʧܣ0ɹ
*/
int	drv_qmc6310_get_mag_data(qmc_data_t	*p_data);






#ifdef __cplusplus
}
#endif

#endif
















